package com.dsic.gj_erp.service.jhgk.impl;


import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jhgk.DmQfxq;
import com.dsic.gj_erp.bean.jhgk.DmSygdMx;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.mapper.jhgk.DmQfxqMapper;
import com.dsic.gj_erp.service.jhgk.DmQfxqService;
import com.dsic.gj_erp.service.jhgk.DmYdjhService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.*;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.stream.Collectors;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-18
 */
@Service
public class DmQfxqServiceImpl extends ServiceImpl<DmQfxqMapper, DmQfxq> implements DmQfxqService {

    @Resource
    private DmYdjhService ydjhService;

    @Override
    @Transactional
    public void saveXzList(List<DmQfxq> list, String username, String day){
        list.forEach(l->{
            l.setDcPl(l.getDcPl().length() == 1 ? "00" + l.getDcPl() : l.getDcPl().length() == 2 ? "0" + l.getDcPl() : l.getDcPl());
            DmQfxq qfxq=this.getOne(new QueryWrapper<DmQfxq>()
                    .eq("dc_ch",l.getDcCh())
                    .eq("dc_pl",l.getDcPl())
                    .eq("DC_FD",l.getDcFd())
            );
            if (ObjUtil.isNotEmpty(qfxq)){
                l.setDrcs(qfxq.getDrcs()+1);
                l.setXzglxqOld(qfxq.getXzglxq());
                l.setDrr(username);
                l.setDrrq(day);
                //状态 2拖期 1提前
                if (l.getXzglxq().compareTo(qfxq.getXzglxq())>0){
                    l.setXqzt("2");
                }
                if (l.getXzglxq().compareTo(qfxq.getXzglxq())<0){
                    l.setXqzt("1");
                }
                this.update(new UpdateWrapper<DmQfxq>()
                        .set("xzglxq",l.getXzglxq())
                        .set("xzglxq_old",l.getXzglxqOld())
                        .set("xdb",l.getXdb())
                        .set("xskj",l.getXskj())
                        .set("xpt",l.getXpt())
                        .set("xyw",l.getXyw())
                        .set("xxc",l.getXxc())
                        .set("xtxc",l.getXtxc())
                        .set("drcs",l.getDrcs())
                        .set("xqzt",l.getXqzt())
                        .set("drrq",l.getDrrq())
                        .set("drr",l.getDrr())
                        .eq("dc_ch",l.getDcCh())
                        .eq("dc_pl",l.getDcPl())
                        .eq("DC_FD",l.getDcFd())
                );
            }else {
                l.setDrr(username);
                l.setDrrq(day);
                this.save(l);
            }


        });
    }

    @Override
    @Transactional
    public void saveDzList(List<DmQfxq> list,String username,String day){
        List<DmQfxq> toYdList=new ArrayList<>();
        list.forEach(l->{
            l.setDcPl(l.getDcPl().length() == 1 ? "00" + l.getDcPl() : l.getDcPl().length() == 2 ? "0" + l.getDcPl() : l.getDcPl());
            DmQfxq qfxq=this.getOne(new QueryWrapper<DmQfxq>()
                    .eq("dc_ch",l.getDcCh())
                    .eq("dc_pl",l.getDcPl())
                    .eq("DC_FD",l.getDcFd())
            );
            if (ObjUtil.isNotEmpty(qfxq)){
                l.setDrr(username);
                l.setDrrq(day);
                this.update(new UpdateWrapper<DmQfxq>()
                        .set("dzglxq",l.getDzglxq())
                        .set("dzglxq_old",qfxq.getDzglxq())
                        .set("dqb",l.getDqb())
                        .set("dxc",l.getDxc())
                        .set("dsj",l.getDsj())
                        .set("ddb",l.getDdb())
                        .set("drrq",l.getDrrq())
                        .set("drr",l.getDrr())
                        .eq("dc_ch",l.getDcCh())
                        .eq("dc_pl",l.getDcPl())
                        .eq("DC_FD",l.getDcFd())
                );
            }else {
                l.setDrr(username);
                l.setDrrq(day);
                this.save(l);
            }
            toYdList.add(this.getOne(Wrappers.<DmQfxq>lambdaQuery()
                    .eq(DmQfxq::getDcCh,l.getDcCh())
                    .eq(DmQfxq::getDcPl,l.getDcPl())
                    .eq(DmQfxq::getDcFd,l.getDcFd())
            ));
        });
        generateYdjh(toYdList);
    }

    /**
     * 生成月度计划
     *
     * @param list
     */
    public void generateYdjh(List<DmQfxq> list) {
        //分段
        List<String> ids = list.stream().map(DmQfxq::getId).collect(Collectors.toList());
        //获取对应的 三月滚动计划明细
        //需要再次排产？目前没排
        List<DmYdjh> ydjhList = baseMapper.getYdjh(ids);
        if (ydjhList.size() < 1) {
            System.out.println("当前导入的前方需求没有对应的三月滚动计划！");
        }
//        for (DmYdjh dmYdjh : ydjhList) {
//            ydjhService.remove(new QueryWrapper<DmYdjh>()
//                    .eq("Dc_Ch",dmYdjh.getDcCh())
//                    .eq("Dc_Pl",dmYdjh.getDcPl())
//                    .eq("Tzbh",dmYdjh.getTzbh())
//            );
//        }
        Map<String, List<DmYdjh>> map = ydjhList.stream().collect(Collectors.groupingBy(mx -> mx.getDcCh() +"@"+ mx.getDcPl()));
        this.removeByMulti(map);
        ydjhList.forEach(l->{
            if (StrUtil.isAllNotEmpty(l.getXzglxq(),l.getJssj())){
                //状态 2拖期 1提前 3追加
                if (l.getXzglxq().compareTo(l.getJssj())<0){
                    if (!DateUtil.isSameMonth(DateUtil.parseDate(l.getXzglxq()),DateUtil.parseDate(l.getJssj()))){
                        l.setJhlx("3");
                    }else {
                        l.setJhlx("1");
                    }
                }
                if (l.getXzglxq().compareTo(l.getJssj())>0){
                    l.setJhlx("2");
                }
                l.setJssjOld(StrUtil.isEmpty(l.getJssj())?"":l.getJssj());
                l.setJssj(l.getXzglxq());
            }
        });
        ydjhService.saveBatch(ydjhList);


    }

    private void removeByMulti(Map<String, List<DmYdjh>> map){
        map.forEach((key,list)->{
            String[] str= key.split("@");
            this.removeByMulti(list,str[0],str[1],200);
        });
    }

    private void removeByMulti(List<DmYdjh> list,String dcCh,String dcPl,int size){
        List<String> tzbhList = list.stream().map(DmYdjh::getTzbh).collect(Collectors.toList());
        AtomicInteger index=new AtomicInteger(tzbhList.size()/size);
        do {
            int i = index.decrementAndGet();
            int i1 = tzbhList.size() % ((index.get()) * size);
            int last=i1>0?i1:i*size;
            List<String> list1 = tzbhList.subList((index.get())*size, last);
            this.remove(list1,dcCh,dcPl);
        }while (index.get()>0);
    }

    private void remove(List<String> list,String dcCh,String dcPl){
        ydjhService.remove(Wrappers.<DmYdjh>lambdaQuery()
                .eq(DmYdjh::getDcCh,dcCh)
                .eq(DmYdjh::getDcPl,dcPl)
                .in(DmYdjh::getTzbh,list)
        );
    }

}
